/* mdigest5.c - Test fuer MD5
 */

#define MD 5

#include <stdio.h>
#include <string.h>
#include "global.h"

#include "md5.h"

/* Length of test block, number of test blocks.
 */

static void MDString PROTO_LIST ((char *));
static void MDFile PROTO_LIST ((char *));
static void MDPrint PROTO_LIST ((unsigned char [16]));

#define MD_CTX MD5_CTX
#define MDInit MD5Init
#define MDUpdate MD5Update
#define MDFinal MD5Final

usage()
{
	printf("usage:\n");
	printf("\tmdigest5 -sstring\n");
	printf("\t\tdigests string\n");
	printf("\tmdigest5 <file>\n");
	printf("\t\tdigests <file>\n");
	printf("\t(the result is written to stdout)\n");
}

int main (argc, argv)
int argc;
char *argv[];
{

  if (argc > 1) {
      if (argv[1][0] == '-' && argv[1][1] == 's')
        MDString (argv[1] + 2);
      else if(argv[1][0] != '-')
        MDFile (argv[1]);
      else
	usage();
  }
  else
    usage ();

  return (0);
}

/* Digests a string and prints the result.
 */
static void MDString (string)
char *string;
{
  MD_CTX context;
  unsigned char digest[16];
  unsigned int len = strlen (string);

  MDInit (&context);
  MDUpdate (&context, string, len);
  MDFinal (digest, &context);

  MDPrint (digest);
  printf ("\n");
}


/* Digests a file and prints the result.
 */
static void MDFile (filename)
char *filename;
{
  FILE *file;
  MD_CTX context;
  int len;
  unsigned char buffer[1024], digest[16];

  if ((file = fopen (filename, "rb")) == NULL)
    printf ("%s can't be opened\n", filename);
  else {
    MDInit (&context);
    while (len = fread (buffer, 1, 1024, file))
        MDUpdate (&context, buffer, len);
    MDFinal (digest, &context);

    fclose (file);

    MDPrint (digest);
    printf ("\n");
  }
}

/* Prints a message digest in hexadecimal.
 */
static void MDPrint (digest)
unsigned char digest[16];
{
  unsigned int i;

  for (i = 0; i < 16; i++)
    printf ("%02x", digest[i]);
}
